# Introduction

This project is a sample implementation of all the knowledge learned in the DevOps Bootcamp from Techworld with Nana for Module 11.

The objectives here are similar to what is being asked on the Capstore Project 1.

<img width="650" alt="petclinic-screenshot" src="https://lh4.googleusercontent.com/jelcq2B8-7XD15Gz1HJ9_PHaXNVqVEiD2-LzlwAv7wGwSCpQHZHer5l_xVcvFHlE4x0JAj1jo_rifuAhi8I2AWFr3On573_9SHz6Nz-Unkcm4LlA3rsu0lABlMqveTVkYg=w424">

This project uses the open source project named pring-petclinic as the app being deployed instead of the bootcamp lecture application.

Bootcamp Chapter 11 Git Repo: git@gitlab.com:twwnana/aws-eks/chapter11.git

# Reqiurements before running the Jenkins Pipeline

- ECR Container must exist (You must manually create this ECR Repo on your tenant account.).
- AWS Bucket for Terraform State must exist (You must manually created on your tenant account.).
- EKS Cluster must exist (This can be created using terraform which is included in this repository.).

# Creating the EKS Cluster (must be done before running the pipeline)

1. Create the AWS Bucket for the terraform state
2. Clone the resitory git@gitlab.com:twwnana/capstoneprojects/capstone-proj01.git
3. Update the main.tf to refer to the bucket name you created and the default region.
4. From the project root create the file terraform\custom-variables\vpc-variables-tfvars and update the following fields appropriately.
```
app_name       = "petclinic"
cluster_name   = "petclinic_k8s_cluster"
env            = "dev"
instance_types = "t2.medium"
vpc_cidr_block = "10.0.0.0/16"
private_subnets_cidr_blocks = ["10.0.0.0/24", "10.0.1.0/24", "10.0.2.0/24"]
public_subnets_cidr_blocks  = ["10.0.3.0/24", "10.0.4.0/24", "10.0.5.0/24"]

```
5. Navigate to the Terraform folder and issue the command below to intialize terraform.
```
terraform init
```
6. Apply the terraform configuration to create the EKS cluster. NOTE: This will take a while to complete.
```
terraform apply -var-file custom-variables/vpc-variables.tfvars -auto-approve
```

# Running the Pipeline
Once the EKS cluster and EKS container Repo is created, we are now ready to run the pipeline. 
The pipeline requires 5 parameters:
- The ECR repository namespace (The repository namespace part of the repository URI. <repository_namespace>/<repository_name>:<tag_name>)
- The ECR repository name (The repository name part of the repository URI. <repository_namespace>/<repository_name>:<tag_name>)
- The ECR password to use (This can be generated by issuing the following command below).
```
aws ecr get-login-password --region <region_name>
```
- The MYSQL database admin username to assign to the database.
- The MYSQL database admin password to assign to the database.

# Testing the application Output
When the pipeline is successful connect to the cluster by executing the command below to update your kubeconfig for the K8s cluster.

NOTE: the cluster_name is dependent to the terraform variable cluster_name above
```
aws eks update-kubeconfig --name petclinic_k8s_cluster
```

Enumerate the cluster services in the default namespace and look for the "petclinic-service"
```
kubectl get service
```

Copy the EXTERNAL-IP of the petclinic-service and paste it on the browser.
NOTE: The application may take 1-2 minutes before it can service requestes so as long as you see the pods running, wait a few mintues.

## Tech Stack
**Infrastructure:** AWS ECR, AWS EKS

**Technologies:** Containerization (Docker and AWS ECR), CICD Pipeline (Jenkins), Git (Code Versioning), Maven (application), Terraform (AWS EKS provisioning)

# Credits
The original spring-petclinic can be found at https://github.com/spring-projects/spring-petclinic